-- INV初期値用の表
-- INVの入力SRCの仮数部の上位５bit（MSB除く）から、解の仮数部の上位4bit（MSB除く）を表引き
-- 

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity INV_table is

	port(M    : in std_logic_vector(4 downto 0);
	     MANT : out std_logic_vector(3 downto 0));

end INV_table;

architecture STRUCTURE of INV_table is

begin -- STRUCTURE

--MANT<= --"0000" when M = "00000" else
--       "1111" when M = "00001" else
--       "1110" when M = "00010" else
--       "1101" when M = "00011" else
--       "1100" when M = "00100" else
--       "1011" when M = "00101" else
--       "1010" when M(4 downto 1) = "0011" else
--       "1001" when M = "01000" else
--       "1000" when M = "01001" or M = "01010" else
--       "0111" when M = "01011" or M = "01100" else
--       "0110" when M = "01101" or M = "01110" else
--       "0101" when M = "01111" or M = "10000" else
--       "0100" when M = "10001" or M(4 downto 1) = "1001" else
--       "0011" when M(4 downto 1) = "1010" else
--       "0010" when M = "11000" or M(4 downto 1) = "1011" else
--       "0001" when M(4 downto 2) = "110" or M = "11100" else
--       "0000";

MANT<= --"0000" when M = "00000" else
       "1111" when M = "00001" else
       "1110" when M = "00010" else
       "1101" when M = "00011" else
       "1100" when M = "00100" else
       "1011" when M = "00101" else
       "1010" when M = "00110" else
       "1010" when M = "00111" else
       "1001" when M = "01000" else
       "1000" when M = "01001" else
       "1000" when M = "01010" else
       "0111" when M = "01011" else
       "0111" when M = "01100" else
       "0110" when M = "01101" else
       "0110" when M = "01110" else
       "0101" when M = "01111" else
       "0101" when M = "10000" else
       "0100" when M = "10001" else
       "0100" when M = "10010" else
       "0100" when M = "10011" else
       "0011" when M = "10100" else
       "0011" when M = "10101" else
       "0010" when M = "11000" else
       "0010" when M = "10110" else
       "0010" when M = "10111" else
       "0001" when M = "11001" else
       "0001" when M = "11010" else
       "0001" when M = "11011" else
       "0001" when M = "11100" else
       "0000";


           
end STRUCTURE;

